<template>
  <div class="creating">
    <form class="form" autocomplete="off" @submit.prevent="createPeriod">
      <div class="form-wrap">
        <!-- meta -->
        <div class="form-fieldset">
          <div class="form-row">
            <label for="title" class="form-label">Назва</label>
            <input id="title" class="form-input" v-model="period.title">
          </div>
          <div class="form-row">
            <label for="exchange_course" class="form-label">Курс обміну (USD/UAH)</label>
            <input id="exchange_course" class="form-input" v-model="period.exchange_course">
          </div>
          <div class="form-row">
            <label for="days_expired" class="form-label">Днів в періоді</label>
            <input id="days_expired" class="form-input" v-model="period.days_expired">
          </div>
        </div>

        <!-- bookkeeping / taxes / savings-->
        <div v-for="(fields, i) in structure" :key="i" class="form-fieldset">
          <div class="form-fieldset__title">
            {{fields.title}}:
            <span class="add-field" @click="addField(fields.key,i)">
            Додати поле
          </span>
          </div>
          <div v-for="(item, i) in period.bookkeeping[fields.key]"
               :key="i"
               class="form-row">
            <label :for="`${i}_${fields.key}`" class="form-label" v-if="!item.newField">
              {{item.title}} ({{item.currency}})

            </label>
            <div class="form-label" v-else>
              <input :id="`${i}_${fields.key}-name`"
                     class="form-input-label"
                     placeholder="Введіть назву"
                     v-model="item.title">
            </div>
            <input :id="`${i}_${fields.key}`"
                   class="form-input"
                   v-model="item.value"
                   @focus="onFocus"
                   @blur="onBlur">
            <!-- taxes calc -->
            <div class="calc-field" v-if="item.calc">
              <span class="calc-field__toggle" @click="item.calc.show = !item.calc.show">
                Розрахувати {{item.title}}
              </span>
              <div class="calc-field__boxes" v-if="item.calc.show">
                <div class="calc-field__box">
                  <label :for="`${i}_${fields.key}_calc_0`" class="form-label">
                    Ставка (%)
                  </label>
                  <input
                    :id="`${i}_${fields.key}_calc_0`"
                    class="form-input"
                    v-model="item.calc.koef"
                    @focus="onFocus"
                    @blur="onBlur">
                </div>
                <div class="calc-field__box">
                  <label :for="`${i}_${fields.key}_calc_1`" class="form-label">
                    Всі надходження ({{item.currency}})
                  </label>
                  <input
                    :id="`${i}_${fields.key}_calc_1`"
                    class="form-input"
                    v-model="item.calc.summ"
                    @focus="onFocus"
                    @blur="onBlur"
                    @input="calc(item)">
                </div>
              </div>
            </div>
            <!-- taxes calc end -->
            <button v-if="item.newField" class="form-delete" @click="deleteField(fields.key,i)">
              +
            </button>
          </div>
        </div>
      </div>
      <button class="btn btn-primary">
        Створити
      </button>
    </form>
    <PeriodItem :period="period" :example="isExample"/>
  </div>
</template>

<script>
  import constant from '../../constant'
  import { mapActions } from 'vuex'
  import { getCurrentDayTime } from '../../heplres'
  import PeriodItem from '../PeriodItem/PeriodItem'
  import Axios from 'axios'

  export default {
    name: 'CreateForm',
    components: { PeriodItem },
    data () {
      return {
        isExample: true,
        structure: constant.structure,
        period: {
          title: '',
          exchange_course: '',
          days_expired: '30',
          bookkeeping: {
            income: [
              {
                title: 'Надходження',
                currency: 'USD',
                value: '0'
              }
            ],
            taxes: [
              {
                title: 'ЄСВ',
                currency: 'UAH',
                value: constant.taxes.CSP
              },
              {
                title: 'ЄП',
                currency: 'UAH',
                value: '0',
                calc: {
                  show: false,
                  koef: constant.taxes.CT,
                  summ: '0'
                }
              }
            ],
            savings: [],
            home_payments: [],
            shopping: []
          }
        }
      }
    },
    created () {
      // add create date
      this.period.create = getCurrentDayTime() + ''

      // add close flag
      this.period.close = false

      // add Id
      this.period.id = this.getRandomInt(10, 40000) + '_ghh'

      Axios.get(constant.apiEndPoint.exchange_course).then((res) => {
        if (res.data.length) {
          const ex = res.data.filter(item => item.cc === constant.currency.USD)[0]

          this.period.exchange_course = ex.rate.toFixed(2) + ''
        }
      })
    },
    methods: {
      ...mapActions(['addPeriod']),
      getRandomInt (min, max) {
        min = Math.ceil(min)
        max = Math.floor(max)
        return Math.floor(Math.random() * (max - min)) + min
      },
      createPeriod () {
        const period = JSON.parse(JSON.stringify(this.period))

        // clear newField
        this.structure.map(item => period.bookkeeping[item.key].map(item => {
          delete item.calc
          delete item.newField
        }))

        // add period
        this.addPeriod(period)
      },
      addDefaultCurrency (key, index) {
        return this.structure[index].currency
      },
      addDefaultTitle (key, index) {
        return this.structure[index].defaultFieldName + ` #${this.period.bookkeeping[key].length + 1}`
      },
      addDefaultObj (key, index) {
        return {
          title: this.addDefaultTitle(key, index),
          currency: this.addDefaultCurrency(key, index),
          value: 0,
          newField: true
        }
      },
      addField (key, index) {
        this.period.bookkeeping[key].push(this.addDefaultObj(key, index))
      },
      deleteField (key, index) {
        this.period.bookkeeping[key].splice(index, 1)
      },
      onFocus () {
        if (event.target && event.target.value === '0') {
          event.target.value = ''
        }
      },
      onBlur () {
        if (event.target && !event.target.value.length) {
          event.target.value = '0'
        }
      },
      calc (item) {
        item.value = (+item.calc.koef * (+item.calc.summ) / 100).toFixed(2) + ''
        console.log(item)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "../../styles/base/all_base_sheets";

  .creating {
    display: flex;
    flex-flow: row wrap;
    justify-content: space-between;
    align-items: flex-start;
  }

  .form {
    width: 600px;
    padding-right: 50px;

    &-fieldset {
      padding-bottom: 41px;
      margin-bottom: 40px;
      position: relative;

      &__title {
        margin-bottom: 20px;
        font-weight: bold;
        display: flex;
        justify-content: space-between;
      }

      &:before {
        content: '';
        display: block;
        width: 100%;
        height: 1px;
        background: rgba($cl-black, .2);
        position: absolute;
        bottom: 0;
        left: 0;
        right: 0;
        margin: auto;
      }

      &:last-child {
        margin-bottom: 0;
      }
    }

    &-row {
      display: flex;
      flex-flow: row wrap;
      width: 100%;
      position: relative;
      margin-bottom: 20px;
      align-items: center;

      &:last-child {
        margin-bottom: 0;
      }
    }

    &-group {
      margin-bottom: 20px;

      &:last-child {
        margin-bottom: 0;
      }
    }

    &-label {
      margin-right: auto;
      cursor: pointer;
      display: inline-block;
      font-size: 1.6rem;
    }

    &-input-label {
      display: inline-block;
      border: none;
      padding: 0;
      font-size: 1.6rem;
      outline: none;
      text-decoration: underline;

      &::placeholder {
        text-decoration: underline;
      }
    }

    &-input {
      display: block;
      width: 300px;
      height: 38px;
      padding: 0 15px;
      border: 1px solid $cl-black;
      border-radius: 10px;
    }

    &-tips {
      top: 0;
      bottom: 0;
      right: 40px;
      width: 40px;
      position: absolute;
      line-height: 40px;
    }

    .btn {
      margin-top: 50px;
    }

    &-delete {
      position: absolute;
      right: -50px;
      padding: 0;
      -webkit-appearance: none;
      border: none;
      box-shadow: none;
      background: none;
      font-weight: bold;
      @include circle(40px);
      font-size: 30px;
      outline: none;
      transform: rotate(45deg);
    }

    .add-field {
      font-size: 1.4rem;
      text-decoration: underline;
      cursor: pointer;
      font-weight: normal;

      &:hover, &:active {
        text-decoration: none;
      }
    }

    .calc-field {
      padding-right: 0;
      padding-top: 10px;
      flex: 0 0 100%;
      width: 100%;
      max-width: 300px;
      margin-left: auto;
      text-align: right;

      &__toggle {
        font-size: 1.4rem;
        text-decoration: underline;
        cursor: pointer;
        font-weight: normal;

        &:hover, &:active {
          text-decoration: none;
        }
      }

      &__boxes {
        padding-top: 15px;
        text-align: left;
      }

      &__box {
        display: flex;
        align-items: center;
        width: 100%;
        margin-bottom: 20px;

        &:last-child {
          margin-bottom: 0;
        }

        .form-label {
          font-size: 1.4rem;
        }

        .form-input {
          margin-right: 0;
          margin-left: auto;
          width: 100px;
        }
      }
    }
  }
</style>
